
#include <stdio.h>
#include "port.h"
#include "portwatcher.h"

class mywatcher : public portWatcher
{
public:
			mywatcher(port *, const int32 msgs);

	// Should implement if sub-classing
	virtual void	HandleDataRead(const int32 code, void *data, int32 size);

protected:
	int32	fMaxMsgs;

private:
};

mywatcher::mywatcher(port *aPort, const int32 maxmsgs)
	: portWatcher(aPort),
	fMaxMsgs(maxmsgs)
{
}

void
mywatcher::HandleDataRead(const int32 code, void *data, ssize_t size)
{
	printf("HandleDataRead: Code: %d  Size: %d\n", code, size);
	if (MessagesReceived() >= fMaxMsgs)
		Kill();
}

// This routine simply tests whether we can 
// construct a port, send data to it, and 
// read the data back.

main()
{
	port aPort("testport");

	mywatcher watcher(&aPort,3);
	watcher.Run();

	char msg[] = "bigger buffer";
	aPort.Write(100, msg, sizeof(msg));
	aPort.Write(100, msg, sizeof(msg));
	aPort.Write(100, msg, sizeof(msg));
	aPort.Write(100, msg, sizeof(msg));
	aPort.Write(100, msg, sizeof(msg));
	aPort.Write(100, msg, sizeof(msg));
	aPort.Write(100, msg, sizeof(msg));

	long dummy;
	watcher.WaitForExit(&dummy);
/*
	ssize_t	bsize = aPort.CurrentBufferSize();
	char *aBuff = (char *)malloc(bsize+1);
	int32 code;
	aPort.Read(&code, aBuff, bsize);
	aBuff[bsize] = 0;

	printf("Code: %d Size: %d Read: %s\n", code, bsize, aBuff);
*/
}
