//====================================
//  Comparison operators
//  For any class, there should be six
//  <, >, <=, >=, ==, !=
//
// Any class that wants to implement these
// will need to implement a compare function.
//
// compare returns:
// -1 if this > rhs
// 0 if this == rhs
// 1 if rhs > this
//====================================

template <class T>
inline int operator < (const T& left, const T& right)
{
	return left.compare(right) < 0;
}

inline int operator <= (const T& left, const T& right)
{
	return left.compare(right) <= 0;
}

inline int operator > (const T& left, const T& right)
{
	return left.compare(right) > 0;
}

inline int operator >= (const T& left, const T& right)
{
	return left.compare(right) >= 0;
}

inline int operator == (const T& left, const T& right)
{
	return left.compare(right) == 0;
}

inline int operator != (const T& left, const T& right)
{
	return left.compare(right) != 0;
}


